//
//  Enemy.m
//  PlaneGame
//
//  Created by Rannie on 13-10-5.
//  Copyright (c) 2013年 Rannie. All rights reserved.
//

#import "Enemy.h"

#import "SoundsTool.h"

@implementation Enemy

+ (id)enemyWithType:(REnemyType)type size:(CGSize)size gameLevel:(NSInteger)level andGameArea:(CGRect)gameArea
{
    Enemy *enemy = [[Enemy alloc] init];
    
    enemy.type = type;
    
    CGFloat x = arc4random_uniform(gameArea.size.width-size.width) + size.width/2;
    CGFloat y = -size.height/2;
    enemy.position = CGPointMake(x, y);
    
    switch (type)
    {
        case REnemyTypeSmall:
            enemy.hp = 1;
            enemy.speed = arc4random_uniform(3+level)+2;
            enemy.prize = 1;
            break;
        case REnemyTypeMiddle:
            enemy.hp = 5;
            enemy.speed = arc4random_uniform(2+level)+2;
            enemy.prize = 8;
            break;
        case REnemyTypeBig:
            enemy.hp = 15;
            enemy.speed = arc4random_uniform(1+level)+2;
            enemy.prize = 30;
            break;
    }
    
    enemy.toBlowup = NO;
    enemy.blowupFrames = 0;
    
    return enemy;
}

- (void)setToBlowup:(BOOL)toBlowup
{
    if (toBlowup == NO)
    {
        _toBlowup = NO;
    }
    else
    {
        _toBlowup = YES;
        
        RSoundType soundType;
        switch (self.type)
        {
            case REnemyTypeSmall:
                soundType = RSoundTypeSmallBlowup;
                break;
            case REnemyTypeMiddle:
                soundType = RSoundTypeMiddleBlowup;
                break;
            case REnemyTypeBig:
                soundType = RSoundTypeBigBlowup;
                break;
        }
        [[SoundsTool shareSoundsTool] playSoundWithType:soundType];
    }
}

@end
