//
//  EnemyView.m
//  PlaneGame
//
//  Created by Rannie on 13-10-5.
//  Copyright (c) 2013年 Rannie. All rights reserved.
//

#import "EnemyView.h"

#import "Enemy.h"
#import "ImageResources.h"

@implementation EnemyView

- (id)initWithEnemy:(Enemy *)enemy
{
    self = [super init];
    
    if (self)
    {
        self.enemy = enemy;
        
        ImageResources *res = [ImageResources sharedImages];
        
        switch (self.enemy.type)
        {
            case REnemyTypeSmall:
                self.image = res.smallFlyImage;
                self.blowupImages = res.smallBlowupImages;
                break;
            case REnemyTypeMiddle:
                self.image = res.middleFlyImage;
                self.hitImage = res.middleHitImage;
                self.blowupImages = res.middleBlowupImages;
                break;
            case REnemyTypeBig:
                self.image = res.bigFlyImages[0];
                
                self.animationDuration = 0.5f;
                self.animationImages = res.bigFlyImages;
                [self startAnimating];
                
                self.hitImage = res.bigHitImage;
                self.blowupImages = res.bigBlowupImages;
                break;
        }
        
        self.frame = CGRectMake(0, 0, self.image.size.width, self.image.size.height);
        self.center = self.enemy.position;
    }
    
    return self;
}

@end
