//
//  GameModel.m
//  PlaneGame
//
//  Created by Rannie on 13-10-4.
//  Copyright (c) 2013年 Rannie. All rights reserved.
//

#import "GameModel.h"

#import "Hero.h"

#define RMoveOffset 1

@implementation GameModel

+ (id)gameModelWithGameArea:(CGRect)gameArea heroSize:(CGSize)size
{
    GameModel *model = [[GameModel alloc] init];
    
    model.gameArea = gameArea;
    
    model.bgFrame1 = gameArea;
    model.bgFrame2 = CGRectOffset(gameArea, 0, -gameArea.size.height);
    
    model.hero = [Hero heroWithSize:size andGameArea:gameArea];
    MyLog(@"hero:%@", model.hero);
    
    return model;
}

- (void)moveBackground
{
    self.bgFrame1 = CGRectOffset(self.bgFrame1, 0, RMoveOffset);
    self.bgFrame2 = CGRectOffset(self.bgFrame2, 0, RMoveOffset);
    
    CGRect topFrame = CGRectOffset(self.gameArea, 0, -self.gameArea.size.height);
    
    if (self.bgFrame1.origin.y >= self.gameArea.size.height)
    {
        self.bgFrame1 = topFrame;
    }
    else if (self.bgFrame2.origin.y >= self.gameArea.size.height)
    {
        self.bgFrame2 = topFrame;
    }
}

- (Enemy *)createEnemyWithType:(REnemyType)type andSize:(CGSize)size
{
    Enemy *enemy = [Enemy enemyWithType:type size:size gameLevel:self.gameLevel andGameArea:self.gameArea];
    
    return enemy;
}

@end
