//
//  Hero.m
//  PlaneGame
//
//  Created by Rannie on 13-10-4.
//  Copyright (c) 2013年 Rannie. All rights reserved.
//

#import "Hero.h"

#import "Bullet.h"

#define ROffsetH 15.0f

@implementation Hero

+ (id)heroWithSize:(CGSize)size andGameArea:(CGRect)area
{
    Hero *hero = [[Hero alloc] init];
    
    CGFloat x = CGRectGetMidX(area);
    CGFloat y = CGRectGetMaxY(area) - size.height/2;
    hero.position = CGPointMake(x, y);
//    MyLog(@"hero pos:%@", NSStringFromCGPoint(hero.position));
    
    hero.size = size;
    hero.bombCount = 0;
    hero.isEnhanced = NO;
    hero.enhancedTime = 0;
    
    return hero;
}

- (void)fire
{
    CGSize bulletSize;
    if (self.isEnhanced)
    {
        bulletSize = self.bulletEnhancedSize;
    }
    else
    {
        bulletSize = self.bulletNormalSize;
    }
    
    CGFloat x = self.position.x;
    CGFloat y = self.position.y - self.size.height/2 - bulletSize.height;
    CGPoint position = CGPointMake(x, y);
    
    Bullet *bullet = [Bullet bulletWithPostion:position andIsEnhanced:self.isEnhanced];
    self.currentBullet = bullet;
//    MyLog(@"fire");
}

- (CGRect)collisionRect
{
    CGFloat x = self.position.x - self.size.width/3.0;
    CGFloat y = self.position.y - self.size.height/2.0 + ROffsetH;
    CGFloat w = self.size.width/3.0;
    CGFloat h = self.size.height - 2*ROffsetH;
    
    return CGRectMake(x, y, w, h);
}

@end
