//
//  MainViewController.m
//  PlaneGame
//
//  Created by Rannie on 13-10-4.
//  Copyright (c) 2013年 Rannie. All rights reserved.
//

#import "MainViewController.h"

#import "LaunchView.h"
#import "TitleView.h"

#import "PlaneGameViewController.h"

@interface MainViewController ()

//加载程序视图
@property (weak, nonatomic) LaunchView *launchingView;

//首页标题视图
@property (weak, nonatomic) TitleView *titleView;

//游戏视图控制器
@property (strong, nonatomic) PlaneGameViewController *gameVC;

@end

@implementation MainViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    LaunchView *launchView = [[LaunchView alloc] initWithFrame:self.view.bounds];
    [self.view addSubview:launchView];
    self.launchingView = launchView;
    
    [self performSelectorInBackground:@selector(loadResources) withObject:nil];
}

- (void)loadResources
{
    [NSThread sleepForTimeInterval:2.0f];
    
    self.gameVC = [[PlaneGameViewController alloc] init];
    [self.gameVC loadResource];
    
    TitleView *logoView = [[TitleView alloc] initWithFrame:self.view.bounds];
    [self.view addSubview:logoView];
    self.titleView = logoView;
    
    [self.launchingView removeFromSuperview];
    
    [self performSelectorInBackground:@selector(beginGame) withObject:nil];
}

- (void)beginGame
{
    [NSThread sleepForTimeInterval:1.0f];
    
    [self.launchingView removeFromSuperview];
    
    [self.view addSubview:self.gameVC.view];
}

@end
